
Imports Infragistics.Win.UltraWinTree
Imports Infragistics.Win
Imports Infragistics.Shared

Public Class Form1
    Private ds As New DataSet
    Private dt As New DataTable

    Private Function GetData() As Integer

        Dim theProjects As DataTable = ds.Tables.Add("Projects")
        theProjects.Columns.Add("ProjectID", GetType(Integer))
        theProjects.Columns.Add("ProjectKey", GetType(Integer))
        theProjects.Columns.Add("ProjectName", GetType(String))
        theProjects.Columns.Add("ProjectStartTime", GetType(DateTime))

        theProjects.Rows.Add(New [Object]() {1, 1, "Project 1", DateTime.Today})
        theProjects.Rows.Add(New [Object]() {2, 2, "Project 2", DateTime.Today})
        theProjects.Rows.Add(New [Object]() {3, 3, "Project 3", DateTime.Today})

        Dim theTasks As DataTable
        theTasks = ds.Tables.Add("Tasks")
        theTasks.Columns.Add("TaskID", GetType(Integer))
        theTasks.Columns.Add("ProjectKey", GetType(Integer))
        theTasks.Columns.Add("DateStart", GetType(DateTime))
        theTasks.Columns.Add("TaskName", GetType(String))

        theTasks.Rows.Add(New [Object]() {1, 1, DateTime.Now, "Planning 1 1"})
        theTasks.Rows.Add(New [Object]() {2, 1, DateTime.Now, "Planning 1 2"})
        theTasks.Rows.Add(New [Object]() {3, 1, DateTime.Now, "Planning 1 3"})

        theTasks.Rows.Add(New [Object]() {4, 2, DateTime.Now, "Planning 2 1"})
        theTasks.Rows.Add(New [Object]() {5, 2, DateTime.Now, "Planning 2 2"})
        theTasks.Rows.Add(New [Object]() {6, 2, DateTime.Now, "Planning 2 3"})

        ds.Relations.Add("Project", ds.Tables("Projects").Columns("ProjectKey"), ds.Tables("Tasks").Columns("ProjectKey"))

    End Function

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Try
            Call GetData()
            With Me.UltraTree1
                .ViewStyle = UltraWinTree.ViewStyle.OutlookExpress
                .Override.ShowExpansionIndicator = UltraWinTree.ShowExpansionIndicator.CheckOnDisplay
                .ColumnSettings.AutoFitColumns = AutoFitColumns.ResizeAllColumns
                .ColumnSettings.ShowBandNodes = ShowBandNodes.OnlyForSiblingBands
                .SetDataBinding(ds, "Projects")
            End With

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

    End Sub

    Private Sub UltraTree1_AfterSelect(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinTree.SelectEventArgs) Handles UltraTree1.AfterSelect

    End Sub

#Region " ColumnSet Generated "
    Private Sub ultraTree1_ColumnSetGenerated(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinTree.ColumnSetGeneratedEventArgs) Handles UltraTree1.ColumnSetGenerated

     

        If e.ColumnSet.Key = "Project" Then
            e.ColumnSet.NodeTextColumn = e.ColumnSet.Columns("TaskName")
        End If

        If e.ColumnSet.Key = "Projects" Then
            For Each _col As UltraWinTree.UltraTreeNodeColumn In e.ColumnSet.Columns
                _col.Visible = False
            Next

            e.ColumnSet.Columns("Project").Visible = True
            e.ColumnSet.Columns("ProjectName").Visible = True

            e.ColumnSet.NodeTextColumn = e.ColumnSet.Columns("ProjectName")
        End If
    End Sub
#End Region

#Region " ultraTree1_InitializeDataNode "
    Private Sub ultraTree1_InitializeDataNode(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinTree.InitializeDataNodeEventArgs) Handles UltraTree1.InitializeDataNode
        If e.Node.Parent Is Nothing Then
            e.Node.Expanded = True
        End If
    End Sub
#End Region

#Region " ultraTree1_AfterDataNodesCollectionPopulated "
    Private Sub ultraTree1_AfterDataNodesCollectionPopulated(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinTree.AfterDataNodesCollectionPopulatedEventArgs) Handles UltraTree1.AfterDataNodesCollectionPopulated
        Dim column As UltraTreeNodeColumn
        For Each column In e.Nodes.ColumnSetResolved.Columns
            column.PerformAutoResize()
        Next
    End Sub
#End Region
End Class
